function checkLoaded(targetName, Resources) {
    if (Resources.length != 0) {
        for (i = 0; i < Resources.length; i++) {
            AR.logger.debug("ah");
            if (Resources[i].JSON["targetName"] == targetName) {
                return i;
            }
        }
    }
    AR.logger.debug("-1");
    return -1;
}
var World = {
	 loaded: false,
	init: function initFn() {
		this.createOverlays();
	},

	Resources: new Array(),
	createOverlays: function createOverlaysFn() {
	    AR.logger.activateDebugMode();
	    World.tracker = new AR.InstantTracker();
	    World.instantTrackable = new AR.InstantTrackable(World.tracker);
	    var JSONObject = {
	        action: "GetURLWTC"
	    };
	    AR.platform.sendJSONObject(JSONObject);
	},

	setWorld: function setWorldFn(URLJSON) {
	    AR.logger.debug(URLJSON["Tracker"]);
	    var tgc = new AR.TargetCollectionResource(URLJSON["Tracker"]);
	    World.tracker = new AR.ImageTracker(tgc, {
	        onloaded: this.worldLoaded
	    });
	    World.instantTrackable.enabled = false;
	    World.trackable = new AR.ImageTrackable(this.tracker, "*", {
	        onImageRecognized: function onImageRecognizedFn(targetName) {
	            AR.logger.debug("targetName");
	            var a = checkLoaded(targetName, World.Resources);
	            AR.logger.debug("ah");
	            if (a == -1) {
	                var JSONObject = {
	                    "action": "GetURL",
	                    "name": targetName
	                };
	                AR.platform.sendJSONObject(JSONObject);
	            }
	            else {
	                if (World.Resources[a].JSON["Relative"] != '0') {
	                    AR.logger.debug("par l");
	                    if (World.Resources[a].JSON["type"] == "VID") {
	                        World.Resources[a].Drawable.resume();
	                    }
	                    else
	                        World.Resources[a].Drawable.enabled = true;
	                }
	                else
	                    $("#content").load(World.Resources[a].JSON["Resource"]);
	            }
	        },
	        onImageLost: function onImageLostFn(targetName) {
	            var a = checkLoaded(targetName, World.Resources);
	            AR.logger.debug(a);
	            if (a != -1) {
	                if (World.Resources[a].JSON["Relative"] != '0') {
	                    if (World.Resources[a].JSON["type"] == "VID") {
	                        World.Resources[a].Drawable.pause();
	                    }
                        else
	                        World.Resources[a].Drawable.enabled = false;
	                }
	                else
	                    $("#content").html("");
                }    
	        }
	    });
	},

	getRes: function getResFn(URLJSON) {
        AR.logger.debug("OK");
	    AR.logger.debug(JSON.stringify(URLJSON));
	    Object.keys(URLJSON).forEach(function (k) {
	        if (k == "Resource") {
	            Res_x = parseFloat(URLJSON["x"], 10);
	            Res_y = -(parseFloat(URLJSON["y"], 10));
	            Res_Size = parseFloat(URLJSON["Size"].replace(",", "."), 10);
                AR.logger.debug(Res_y);
                AR.logger.debug(Res_x);
                AR.logger.debug(Res_Size);
	            switch (URLJSON["type"]) {
	                case "IMG":
	                    IRES = new AR.ImageResource(URLJSON["Resource"]);
	                    var Resource = {
	                        JSON: URLJSON,
	                        Drawable: new AR.ImageDrawable(IRES, Res_Size, {
	                            translate: {
	                                x: Res_x,
	                                y: Res_y
	                            }
	                        })
	                    };
	                    World.Resources.push(Resource);
	                    World.Resources[World.Resources.length - 1].Drawable.play(-1);
	                    break;
	                case "VID":
	                    var Resource = {
	                        JSON: URLJSON,
	                        Drawable: new AR.VideoDrawable(URLJSON["Resource"], Res_Size, {
	                            translate: {
	                                x: Res_x,
	                                y: Res_y
	                            }
	                        })
	                    };
	                    World.Resources.push(Resource);
	                    World.trackable.drawables.addCamDrawable(World.Resources[World.Resources.length - 1].Drawable);
	                    break;
	                case "HTML":
	                    var Resource = {
	                        JSON: URLJSON
	                    };
                        var vpH = (256 * (224/156)) | 0;
                        var vpW = (1024 * (156/224)) | 0;
	                    if (URLJSON["Relative"] == 'relative') {
	                        Resource.Drawable = new AR.HtmlDrawable({
	                            uri: URLJSON["Resource"]
	                        }, Res_Size, {
	                            translate: {
	                                x: Res_x,
	                                y: Res_y
	                            },
	                            viewportWidth: 744,
	                            viewportHeight: 1024,
                                allowDocumentLocationChanges: true,
	                            //orizontalAnchor: AR.CONST.HORIZONTAL_ANCHOR.RIGHT,
	                            //verticalAnchor: AR.CONST.VERTICAL_ANCHOR.TOP,
	                            clickThroughEnabled: true
	                        });
	                        World.trackable.drawables.addCamDrawable(Resource.Drawable);
	                    }
	                    else
	                        $("#content").load(URLJSON["Resource"]);
	                    World.Resources.push(Resource);
	                    break;
	            }
	            World.lastTargetName = URLJSON["targetName"];
	        }
	    });
	},

	worldLoaded: function worldLoadedFn() {
		var cssDivLeft = " style='display: table-cell;vertical-align: middle; text-align: right; width: 50%; padding-right: 15px;'";
		var cssDivRight = " style='display: table-cell;vertical-align: middle; text-align: left;'";
		document.getElementById('loadingMessage').innerHTML =
			"<div" + cssDivLeft + ">Scan Target &#35;1 (surfer):</div>" +
			"<div" + cssDivRight + "><img src='assets/AudioSpot_640_72dpi.jpg'></img></div>";

		setTimeout(function() {
			var e = document.getElementById('loadingMessage');
			e.parentElement.removeChild(e);
		}, 10000);
	}
};

World.init();